=== debian/changelog ===
gammaray (2.11.0-2ubuntu1) focal; urgency=medium

  * Disable LauncherTest and ClientConnectionTest that fail on Ubuntu because
    of ptrace protection.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sat, 11 Apr 2020 12:38:21 +0300

gammaray (2.11.0-2) unstable; urgency=medium

  * Team upload.
  * Ignore tests results on s390x (closes: #949903). They are currently
    failing because of QTBUG-56975, on big endian systems green and blue
    colors are swapped.
  * Make the tests results fatal on amd64, arm64, i386 and ppc64el.

 -- Dmitry Shachnev <mitya57@debian.org>  Sun, 16 Feb 2020 00:35:00 +0300

gammaray (2.11.0-1) unstable; urgency=medium

  * Team upload.
  * Acknowledge NMU, thanks Yanhao Mo!
  * New upstream release (closes: #909927).
  * Update Vcs fields to reflect qt-extras → extras move.
  * Refresh debian-archs-fix-build.patch.
  * Fix mkspecs installation path (qt-system-paths.patch).
  * Update debian/copyright.
  * Simplify debian/rules by using the default build directory.
  * Stop setting GAMMARAY_BUILD_DOCS=false, to get the manpage built.
  * Build-depend on qtlocation5-dev to enable positioning_ui plugin.
  * Add runtime QML dependencies for the positioning_ui plugin.
  * Build-depend on glslang-tools to enable GL shader code validation.
  * Remove debian/gammaray-probe-qt4.*, this package is no longer built.
  * Update to debhelper compat level 12.
  * Drop libvtk6-qt-dev build-dependency. Upstream has ported to VTK7 but
    according to them the objectvisualizer_ui plugin is “just for toying
    around, highly experimental”.
  * Install more files reported by dh_missing.
  * Update Homepage URL.
  * Build-depend on qtwebengine5-dev only on architectures where it is
    available.
  * Bump Standards-Version to 4.4.0, no changes needed.

 -- Dmitry Shachnev <mitya57@debian.org>  Tue, 27 Aug 2019 22:01:03 +0300
